export declare enum PathPartType {
    function = "function",
    object = "object",
    string = "string",
    number = "number",
    boolean = "boolean",
    symbol = "symbol",
    undefined = "undefined",
    bigint = "bigint"
}
export interface BasePathPart {
    key: string;
    type: Exclude<PathPartType, PathPartType.function>;
    stackTrace: string;
}
export interface FunctionPathPart {
    key: string;
    type: PathPartType.function;
    callArgs: any[];
    stackTrace: string;
}
export declare type PathPart = BasePathPart | FunctionPathPart;
export interface TracePropAccessOptions {
    callback?(paths: PathPart[][], result: any): void;
    shouldFollow?(target: any, propKey: any): boolean;
    maybeCreateAsyncTrap?(target: any, propKey: any, paths: PathPart[][]): Promise<void> | null;
}
export declare function tracePropAccess(obj: any, options: TracePropAccessOptions, paths?: PathPart[][]): any;
